from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, File, String, Int

Samtools_Calmd_V0_1_0 = CommandToolBuilder(tool="samtools_calmd", base_command=["samtools", "calmd"], inputs=[ToolInput(tag="in_change_identical_bases", input_type=Boolean(optional=True), prefix="-e", doc=InputDocumentation(doc="change identical bases to '='")), ToolInput(tag="in_uncompressed_bam_output", input_type=Boolean(optional=True), prefix="-u", doc=InputDocumentation(doc="uncompressed BAM output (for piping)")), ToolInput(tag="in_compressed_bam_output", input_type=Boolean(optional=True), prefix="-b", doc=InputDocumentation(doc="compressed BAM output")), ToolInput(tag="in_ignored_input_format", input_type=Boolean(optional=True), prefix="-S", doc=InputDocumentation(doc="ignored (input format is auto-detected)")), ToolInput(tag="in_modify_quality_string", input_type=Boolean(optional=True), prefix="-A", doc=InputDocumentation(doc="modify the quality string")), ToolInput(tag="in_use_quiet_mode", input_type=Boolean(optional=True), prefix="-Q", doc=InputDocumentation(doc="use quiet mode to output less debug info to stdout")), ToolInput(tag="in_compute_bq_tag", input_type=Boolean(optional=True), prefix="-r", doc=InputDocumentation(doc="compute the BQ tag (without -A) or cap baseQ by BAQ (with -A)")), ToolInput(tag="in_extended_baq_better", input_type=Boolean(optional=True), prefix="-E", doc=InputDocumentation(doc="extended BAQ for better sensitivity but lower specificity")), ToolInput(tag="in_no_pg", input_type=Boolean(optional=True), prefix="--no-PG", doc=InputDocumentation(doc="do not add a PG line")), ToolInput(tag="in_input_fmt_option", input_type=File(optional=True), prefix="--input-fmt-option", doc=InputDocumentation(doc="[=VAL]\nSpecify a single input file format option in the form\nof OPTION or OPTION=VALUE")), ToolInput(tag="in_output_fmt", input_type=String(optional=True), prefix="--output-fmt", doc=InputDocumentation(doc="[,OPT[=VAL]]...\nSpecify output format (SAM, BAM, CRAM)")), ToolInput(tag="in_output_fmt_option", input_type=File(optional=True), prefix="--output-fmt-option", doc=InputDocumentation(doc="[=VAL]\nSpecify a single output file format option in the form\nof OPTION or OPTION=VALUE")), ToolInput(tag="in_reference", input_type=File(optional=True), prefix="--reference", doc=InputDocumentation(doc="Reference sequence FASTA FILE [null]")), ToolInput(tag="in_threads", input_type=Int(optional=True), prefix="--threads", doc=InputDocumentation(doc="Number of additional threads to use [0]")), ToolInput(tag="in_verbosity", input_type=Int(optional=True), prefix="--verbosity", doc=InputDocumentation(doc="Set level of verbosity\n")), ToolInput(tag="in_eu_bra_esq", input_type=Boolean(optional=True), prefix="-eubrAESQ", doc=InputDocumentation(doc="")), ToolInput(tag="in_aln_dot_bam", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_ref_dot_fast_a", input_type=String(), position=1, doc=InputDocumentation(doc=""))], outputs=[ToolOutput(tag="out_output_fmt_option", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_fmt_option", type_hint=File()), doc=OutputDocumentation(doc="[=VAL]\nSpecify a single output file format option in the form\nof OPTION or OPTION=VALUE"))], container="quay.io/biocontainers/samtools:1.11--h6270b1f_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Samtools_Calmd_V0_1_0().translate("wdl")

